<?php
namespace Accounts\Auth\Controller;

use Accounts\Auth\Controller\AppController;
use Cake\Event\Event;
use Cake\Mailer\MailerAwareTrait;

/**
 * Users Controller
 *
 * @property \Accounts\Auth\Model\Table\UsersTable $Users
 *
 * @method \Accounts\Auth\Model\Entity\User[]|\Cake\Datasource\ResultSetInterface paginate($object = null, array $settings = [])
 */
class UsersController extends AppController
{

    use MailerAwareTrait;

    public function beforeRender(Event $event)
    {
        parent::beforeRender($event);
        $this->viewBuilder()->setHelpers(['Materialize.Form']);
    }

    public function initialize()
    {
        parent::initialize(); // TODO: Change the autogenerated stub
        $this->loadModel('Accounts/Admin.EmailDomains');
        $this->loadComponent('Accounts/Auth.Remember');
        $this->loadComponent('Cookie');
        $this->Auth->setConfig('authenticate', [
            'Form' => [
                'fields' => ['username' => 'email'],
            ]
        ]);
        $this->Auth->constructAuthenticate();
    }

    public function login()
    {
        if ($this->Auth->user()) {
            return $this->redirect($this->Auth->redirectUrl());
        }

        $remember = $this->Cookie->read('remember');

        if ($remember) {
            $user = $this->Users->find()
                ->where(['id' => $remember['id']])
                ->first();

            if (!empty($user) && $user['remember_token'] == $remember['token']) {
                return $this->Remember->authRemember($this->Users, $user);
            }
        }

        $emailDomains = $this->EmailDomains->find('list', [
            'keyField' => 'domain',
            'valueField' => 'domain'
        ]);

        $this->set(compact('emailDomains'));

        if ($this->request->is('post')) {
            $user = $this->Auth->identify();
            if ($user) {
                if ($user['active']) {
                    $this->Auth->setUser($user);
                    $this->request->getSession()->write('User', $user);

                    $remember = $this->request->getData('remember') ?? null;
                    $user = $this->Users->get($this->Auth->user('id'));
                    return $this->Remember->authRemember($this->Users, $user, $remember);

                } else {
                    $this->Flash->error(__d('Accounts/auth', 'You need to activate your account to sign in'));
                    return;
                }
            }
            $this->Flash->error(__d('Accounts/auth', 'Invalid username or password, try again'));
        }
    }

    public function logout()
    {
        $this->request->getSession()->delete('User');
        $this->Flash->success(__d('Accounts/auth', 'You have successfully logged out'));
        return $this->Remember->logoutRemember($this->Users);
    }

    public function register()
    {
        $user = $this->Users->newEntity();
        $emailDomains = $this->EmailDomains->find('list', [
            'keyField' => 'domain',
            'valueField' => 'domain'
        ])
            ->where(['active' => true]);

        $this->set(compact('user', 'emailDomains'));

        if ($this->request->is('post')) {
            $user = $this->Users->patchEntity($user, $this->request->getData());

            if ($this->getEmail($this->request->getData()) == null) {
                return;
            }
            $user->email = $this->getEmail($this->request->getData());
            $user->role_id = ROLE_USER;
            $user->token = md5(uniqid($user->email, true));

            if ($this->Users->save($user)) {
                $this->getMailer('Accounts/Auth.User')->send('welcome', [$user]);
                $this->Flash->success(__d('Accounts/auth', 'Check your email to verify your account'));
                return $this->redirect(['action' => 'login']);
            }
            $this->Flash->error(__d('Accounts/auth', 'The user could not be saved. Please, try again.'));
        }


    }

    private function getEmail($data)
    {
        if (strpos($data['email_prefix'], "@")) {
            $this->Flash->error(__d('Accounts/auth', 'The e-mail is invalid. Inform only the user of the email and select the domain.'));
            return null;
        }
        return $data['email_prefix'] . $data['domain'];
    }

    public function forgotPassword()
    {
        if ($this->request->is('post')) {
            $user = $this->Users->findByEmail($this->request->getData('email'))->toArray();
            if (count($user) > 0) {
                $this->getMailer('Accounts/Auth.User')->send('recoveryPass', [$user]);
                $this->Flash->success(__d('Accounts/auth', 'Email for password recovery sent to your inbox'));
                $this->redirect(['plugin' => null, 'controller' => 'Users', 'action' => 'login']);
            } else {
                $this->Flash->error(__d('Accounts/auth', 'No user found with this email'));
            }
        }
    }

    public function recoveryPass()
    {
        $q_hash = $this->request->getQuery('h');
        $q_id = $this->request->getQuery('i');

        $user = $this->Users->newEntity();
        if ($this->request->is(['post', 'put'])) {
            if ($user = $this->Users->get($q_id)) {
                $user = $this->Users->patchEntity($user, $this->request->getData());

                if ($this->Users->save($user)) {
                    $this->Flash->success(__d('Accounts/auth', 'The password has been saved'));
                    $this->redirect(['plugin' => null, 'controller' => 'Users', 'action' => 'login']);
                } else {
                    $this->Flash->error(__d('Accounts/auth', 'The password could not be saved. Please, try again.'));
                }
            } else {
                $this->Flash->error(__d('Accounts/auth', 'An error has occurred. Search System Administrator'));
            }
        } else {
            if ($user = $this->Users->get($q_id)) {
                $hash = md5(substr($user->password, 0, 30));
                if ($hash != $q_hash) {
                    $this->Flash->error(__d('Accounts/auth', 'You are not allowed to change this password'));
                    $this->redirect(['plugin' => null, 'controller' => 'Users', 'action' => 'login']);
                }
            }
        }
        $user->password = '';
        $this->set(compact('user'));
    }

    public function activateAccount($token = null)
    {
        if ($token == null) {
            $this->Flash->error(__d('Accounts/auth', 'Invalid Token'));
            return $this->redirect(['plugin' => null, 'controller' => 'Users', 'action' => 'login']);
        }

        $user = $this->Users->findByToken($token);

        if ($user->count() != 0) {
            $user = $this->Users->get($user->toArray()[0]['id']);
            if ($user->active) {
                $this->Flash->error(__d('Accounts/auth', 'Your account is already active. Sign in'));
                return $this->redirect(['plugin' => null, 'controller' => 'Users', 'action' => 'login']);
            }

            $user->active = true;
            if ($this->Users->save($user)) {
                $this->Flash->success(__d('Accounts/auth', 'Your account has been successfully activated. Sign in'));
                return $this->redirect(['plugin' => null, 'controller' => 'Users', 'action' => 'login']);
            }
            $this->Flash->error(__d('Accounts/auth', 'An error occurred during account activation.'));
        }
    }

    /**
     * Index method
     *
     * @return \Cake\Http\Response|void
     */
    public function index()
    {
        $users = $this->paginate($this->Users);

        $this->set(compact('users'));
    }

    /**
     * View method
     *
     * @param string|null $id User id.
     * @return \Cake\Http\Response|void
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function view($id = null)
    {
        $user = $this->Users->get($id);

        $this->set('user', $user);
    }

    /**
     * Add method
     *
     * @return \Cake\Http\Response|null Redirects on successful add, renders view otherwise.
     */
    public function add()
    {
        $user = $this->Users->newEntity();
        if ($this->request->is('post')) {
            $user = $this->Users->patchEntity($user, $this->request->getData());
            if ($this->Users->save($user)) {
                $this->Flash->success(__d('Accounts/auth', 'The user has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__d('Accounts/auth', 'The user could not be saved. Please, try again.'));
        }

        $this->set(compact('user'));
    }

    /**
     * Edit method
     *
     * @param string|null $id User id.
     * @return \Cake\Http\Response|null Redirects on successful edit, renders view otherwise.
     * @throws \Cake\Network\Exception\NotFoundException When record not found.
     */
    public function edit($id = null)
    {
        $user = $this->Users->get($id, [
            'contain' => []
        ]);
        if ($this->request->is(['patch', 'post', 'put'])) {
            $user = $this->Users->patchEntity($user, $this->request->getData());
            if ($this->Users->save($user)) {
                $this->Flash->success(__d('Accounts/auth', 'The user has been saved.'));

                return $this->redirect(['action' => 'index']);
            }
            $this->Flash->error(__d('Accounts/auth', 'The user could not be saved. Please, try again.'));
        }

        $this->set(compact('user'));
    }

    /**
     * Delete method
     *
     * @param string|null $id User id.
     * @return \Cake\Http\Response|null Redirects to index.
     * @throws \Cake\Datasource\Exception\RecordNotFoundException When record not found.
     */
    public function delete($id = null)
    {
        $this->request->allowMethod(['post', 'delete']);
        $user = $this->Users->get($id);
        if ($this->Users->delete($user)) {
            $this->Flash->success(__d('Accounts/auth', 'The user has been deleted.'));
        } else {
            $this->Flash->error(__d('Accounts/auth', 'The user could not be deleted. Please, try again.'));
        }

        return $this->redirect(['action' => 'index']);
    }
}
